#ifndef __BASE_TASK__
#define __BASE_TASK__

#include <iostream>
#include <list>
#include <cstring>
#include <mutex>
#include "CR3BPSolverPool.h"

struct BaseTask : public capd::threading::Task  
{
  enum ExecutionOrder { FORWARD, REVERSE };
  volatile bool result = false;
  bool completed = false;
  capd::interval validatedRange = 0.;
  capd::interval parameterRange;
  double stepParameter;
  int taskNo;

  BaseTask(capd::interval parameterRange, double step, int taskNo);
  void report();
  static void runTasks(std::vector<BaseTask*>& tasks, ExecutionOrder order);
  static void releaseTasksMemory(std::vector<BaseTask*>& tasks);
  static std::mutex consoleGuard; 
  static std::vector<BaseTask*>* tasks;
};

#endif
