#ifndef __R3BP_LOGGER_H__
#define __R3BP_LOGGER_H__

#include "capd/capdlib.h"
#include "capd/mpcapdlib.h"
//#define ENABLE_LOGGING

#ifdef ENABLE_LOGGING
  
  /** These conversions are only due to errors in stdlib when printing long doubles under MS Windows*/
  inline void write(long double x){
    std::cout << x << std::endl;
  }

  inline void write(capd::MpFloat x){
    std::cout << x << std::endl;
  }

  inline void write(capd::interval x){
    std::cout << x << std::endl;
  }

  inline void write(capd::MpInterval x){
    std::cout << x << std::endl;
  }

  inline void write(capd::LDVector v){
    std::cout << v << std::endl;
  }

  inline void write(capd::MpVector v){
    capd::DVector u(v.dimension());
    for(int i=0;i<v.dimension();++i)
      u[i] = toDouble(v[i]);
    std::cout << u << std::endl;
  }

  inline void write(capd::IVector v){
    std::cout << v << std::endl;
  }

  inline void write(capd::MpIVector v){
    std::cout << v << std::endl;
  }

  inline void write(capd::LDMatrix v){
    std::cout << capd::vectalg::convertObject<capd::DMatrix>(v) << std::endl;
  }

  inline void write(capd::MpMatrix v){
    capd::DMatrix u(v.numberOfRows(),v.numberOfColumns());
    for(int i=1;i<=v.numberOfRows();++i)
      for(int j=1;j<=v.numberOfRows();++j)
        u(i,j) = toDouble(v(i,j));
    std::cout << u << std::endl;
  }

  inline void write(capd::IMatrix v){
    std::cout << v << std::endl;
  }
  inline void write(capd::MpIMatrix v){
    std::cout << v << std::endl;
  }
  #define PRINT(x) std::cout << #x << "="; write(x);
  #define MESSAGE(x) std::cout << (x) << std::endl;
  #define FLUSH(x) std::cout << x << std::endl;

#else

  #define PRINT(x) 
  #define MESSAGE(x) 
  #define FLUSH(x)

#endif

#endif
