#ifndef __SYMBREAKING_BIFURCATION_HALO_ALGS__
#define __SYMBREAKING_BIFURCATION_HALO_ALGS__

#include "capd/capdlib.h"
#include "CR3BPSolver.h"

struct SymBreakingBifurcationHaloAlgs{
  capd::IVector y, x0, r0, r, X, u0, N, K;  
  capd::IMatrix flowD, D, C;
  capd::IHessian flowH, H;
  capd::IJet J; 

  SymBreakingBifurcationHaloAlgs(int dim);  
  void init(const capd::LDVector& h, const capd::LDMatrix& DP, capd::LDVector& t, const capd::IVector& box, capd::interval mu);
  bool proveBranchBifHaloOrbits(ICR3BP& icr3bp);
  bool checkConvexity(ICR3BP& icr3bp, capd::interval x, capd::interval dy);
};

#endif
