#ifndef __SYMBREAKING_BIFURCATION_LYAP_ALGS__
#define __SYMBREAKING_BIFURCATION_LYAP_ALGS__

#include "capd/capdlib.h"
#include "CR3BPSolver.h"

struct SymBreakingBifurcationLyapAlgs{
  capd::IVector v, u0, u, r0, r;
  capd::IMatrix  D, C;
  capd::interval N;
  
  SymBreakingBifurcationLyapAlgs(int dim);  
  void init(const capd::LDVector& h, const capd::LDMatrix& DP, capd::LDVector& t, const capd::IVector& box, capd::interval mu);
  bool proveBranchLyapunovOrbits(IPCR3BP& icr3bp);
  bool checkMonotonicity(IPCR3BP& icr3bp, capd::interval x, capd::interval dy);
};

#endif
