#include <chrono>
#include <ostream>

// clock functions
inline std::chrono::time_point<std::chrono::system_clock> tic(const char message[], std::ostream& out = std::cout){
  auto start = std::chrono::system_clock::now();
  std::time_t t = std::chrono::system_clock::to_time_t(start);
  out << message << "\n Started: " << std::ctime(&t) << std::endl;
  out << "Available threads: " << CR3BPSolverPool::threadsNo << std::endl;
  return start;
}

inline void tac(std::chrono::time_point<std::chrono::system_clock>& start, std::ostream& out = std::cout){
  auto end = std::chrono::system_clock::now();
  std::chrono::duration<double> elapsed_seconds = end-start;  
  auto t = std::chrono::system_clock::to_time_t(end);
  int h = ((int)elapsed_seconds.count())/3600;
  int m = ((int)elapsed_seconds.count()-h*3600)/60;
  int s = ((int)elapsed_seconds.count())%60;
  out << "Finished: " << std::ctime(&t)
      << "elapsed time: " << h << "hours " << m << "minutes " << s << "seconds\n";    
}
